---
title: OrientationSensor
slug: Web/API/OrientationSensor
tags:
  - API
  - Generic Sensor API
  - Interface
  - Orientation Sensor API
  - OrientationSensor
  - Reference
  - Sensor
  - Sensor APIs
  - Sensors
---
<div>{{APIRef("Generic Sensor API")}}</div>

<p><span class="seoSummary">The <strong><code>OrientationSensor</code></strong> interface of the <a href="/docs/Web/API/Sensor_APIs">Sensor APIs</a> is the base class for orientation sensors. This interface cannot be used directly. Instead it provides properties and methods accessed by interfaces that inherit from it. </span></p>

<p>If a feature policy blocks use of a feature it is because your code is inconsistent with the policies set on your server. This is not something that would ever be shown to a user. See {{httpheader('Feature-Policy')}} for implementation instructions.</p>

<h2 id="Interfaces_based_on_OrientationSensor">Interfaces based on OrientationSensor</h2>

<p>Below is a list of interfaces based on the OrientationSensor interface.</p>

<div class="index">
<ul>
 <li>{{domxref('AbsoluteOrientationSensor')}}</li>
 <li>{{domxref('RelativeOrientationSensor')}}</li>
</ul>
</div>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("OrientationSensor.quaternion")}}</dt>
 <dd>Returns a four element {{jsxref('Array')}} whose elements contain the components of the unit quaternion representing the device's orientation.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("OrientationSensor.populateMatrix()")}}</dt>
 <dd>Populates the given object with the rotation matrix based on the latest sensor reading. The rotation maxtrix is shown below.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_Example">Basic Example</h3>

<p>The following example, which is loosely based on <a href="https://intel.github.io/generic-sensor-demos/orientation-phone/">Intel's Orientation Phone demo</a>,  instantiates an <code>AbsoluteOrientationSensor</code> with a frequency of 60 times a second. On each reading it uses {{domxref('OrientationSensor.quaternion')}} to rotate a visual model of a phone.</p>

<pre class="brush: js">const options = { frequency: 60, referenceFrame: 'device' };
const sensor = new AbsoluteOrientationSensor(options);

sensor.addEventListener('reading', () =&gt; {
  // model is a Three.js object instantiated elsewhere.
  model.quaternion.fromArray(sensor.quaternion).inverse();
});
sensor.addEventListener('error', error =&gt; {
  if (event.error.name == 'NotReadableError') {
    console.log("Sensor is not available.");
  }
});
sensor.start();</pre>

<h3 id="Permissions_Example">Permissions Example</h3>

<p>Using orientation sensors requires requsting permissions for multiple device sensors. Becuase the {{domxref('Permissions')}} uses promises, a good way to request permissions is to use {{jsxref('Promise.all')}}.</p>

<pre class="brush: js">const sensor = new AbsoluteOrientationSensor();
Promise.all([navigator.permissions.query({ name: "accelerometer" }),
             navigator.permissions.query({ name: "magnetometer" }),
             navigator.permissions.query({ name: "gyroscope" })])
       .then(results =&gt; {
         if (results.every(result =&gt; result.state === "granted")) {
           sensor.start();
           ...
         } else {
           console.log("No permissions to use AbsoluteOrientationSensor.");
         }
   });</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Orientation Sensor','#orientationsensor-interface','OrientationSensor')}}</td>
   <td>{{Spec2('Orientation Sensor')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.OrientationSensor")}}</p>
